{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xpglobal.pas,v 1.43 2005/10/28 12:04:16 mw Exp $ }

{ Globale Konstanten/Variablen (FreeXP) und Tools }

{$I XPDEFINE.INC }
{$F+,O+}

unit xpglobal;

interface

const
  verstr      = 'v3.40';     { Versionsnr. - steht nur an dieser Stelle }
  betastr     = ' RC4 (Halloween)';      { '' oder ' beta', ' RCn' usw. }

{ Die folgenden drei Konstanten mssen Sie ergnzen, bevor Sie      }
{ CrossPoint compilieren knnen. Falls Die das compilierte Programm }
{ weitergeben mchten, mssen der angegebene Name korrekt und die   }
{ E-Mail-Adresse erreichbar sein (siehe LIZENZ.TXT).                }
{                                                                   }
{ Beispiel:                                                         }
{                                                                   }
{ const  author_name = 'Ralf Mller';                               }
{        author_mail = 'ralf@t-offline.de';                         }
{        x_copyright = '(c) 2001';                                  }
{                                                                   }
{ Diese Informationen werden bei Programmstart und bei              }
{ /XPoint/Registrierung angezeigt.                                  }

  author_name = 'FreeXP';
  author_fido = '2:2433/460';
  author_mail = 'support@freexp.de';
  author_url  = 'http://www.freexp.de/';
  compiler    = 'Borland Pascal 7.01';

  xp_xp       : string[17] = 'CrossPoint/FreeXP';
  xp_display  : string[6]  = 'FreeXP';
  xp_client   : string[10] = 'CrossPoint';
  xp_origin   : string[21] = '--- CrossPoint/FreeXP';
  xp_old      : string[32] = 'OpenXP/16 (compatibility string)';  { fr UKAW, XPNews u.. }
  x_copyright = '(c) 2002-2005';

type
  { Regeln fr Datentypen unter 16/32 Bit

  Die gre einiger Datentypen unterscheidet sich je nach verwendetem
  Compiler und der Systemumgebung. Folgende Regeln sollten beachtet werden:

  Der im Regelfall zu verwendede Datentyp ist Integer. Dieser Datentyp
  ist unter 16 Bit natrlich 16 Bit gro und unter 32 Bit wiederum 32 Bit
  gro und immer signed (vorzeichenbehaftet). Dieser Datentyp ist immer der
  _schnellste_ fr das System verfgbare Datentyp, sollte also in Schleifen
  usw. wenn mglich genommen und den spezielleren Datentypen vorgezogen
  werden.

  Der Datentyp rtlword ist je nach dem verwendeten Compiler und der damit
  verwendeten RTL 16 oder 32 Bit gro.

  Folgende Datentypen sind immer gleich gro und z.B. fr Records geeignet:
  Byte       1 Byte  unsigned  0..255
  SmallWord  2 Byte  unsigned  0..65535
  DWord      4 Byte  unsigned  0..4294967295
  uint8      1 Byte  unsigned  0..255
  uint16     2 Byte  unsigned  0..65535
  uint32     4 Byte  unsigned  0..4294967295
  uint64     8 Byte  unsigned  0..18446744073709551615
  ( Vorsicht bei BP und VP, diese kennen kein echtes DWord/uint32 und )
  ( auch kein echtes uint64 )

  Integer8   1 Byte  signed   -128..127
  Integer16  2 Byte  signed   -32768..32767
  Integer32  4 Byte  signed   -2147493647..2147493647
  Integer64  8 Byte  signed   -9223372036854775808..9223372036854775807
  }

  { Borland Pascal bis Version 8, 16 Bit }
  { Vorzeichenbehaftete Zahlen }
  integer8  = shortint;
  integer16 = integer;
  integer32 = longint;  
  integer64 = comp;  

  { Vorzeichenlose Zahlen }
  uint8     = byte;
  uint16    = word;
  uint32    = longint;           { Vorsicht: siehe oben! }
  uint64    = comp;              { Vorsicht: siehe oben! }    
  smallint  = integer;
  smallword = word;
  dword     = longint;           { Vorsicht: siehe oben! }
  rtlword   = system.word;       { 16 Bit bei FPC }

  { Zeichenketten }
  { Der Typ HugeString enthlt in der 16 Bit Version einen normalen,
    auf 255 Zeichen begrenzten String, in den 32 Bit Versionen
    einen Hugestring mit bis zu 2 GB Lnge }
  HugeString = String;

const
  DirSepa  = '\';
  WildCard = '*.*';
  _MPMask  = ':\';
  Euro     = 238;

const
  MaxLenFilename = 13;
  MaxLenPathname = 79;

implementation


end.

{
  $Log: xpglobal.pas,v $
  Revision 1.43  2005/10/28 12:04:16  mw
  MW: - Die Halloween-Edition wird RC4 heien.

  Revision 1.42  2005/09/12 07:43:23  mw
  MW: - Vervollstndigung der Variablenumsetzungstabelle (Umdefinieren
        zu grensicheren Variablentypen).

  Revision 1.41  2005/01/01 11:16:30  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.40  2004/05/10 22:20:58  my
  MY:- Konstante 'compiler' ergnzt

  Revision 1.39  2004/05/03 08:33:45  mw
  MW: - Normale Versionnummer wiederhersgestellt

  Revision 1.38  2004/05/03 08:31:09  mw
  MW: - DOSBOX-Edition

  Revision 1.37  2004/01/09 16:18:59  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.36  2003/12/14 13:52:36  mw
  MW: - Erluterung zu den Constanten aus xp0.pas nach xpglobal.pas
        verschoben, da die Constanten selbst sich dort bereits seit
        Jahren befinden.

  Revision 1.35  2003/08/30 23:11:16  my
  MY:- Konstante 'Euro' implementiert

  Revision 1.34  2003/08/20 07:15:25  mw
  MW: - Benutze jetzt notfalls CoPro-Emu, wenn kein CoPro
        vorhanden ist. Alternativversion von xpspace ist nun
        nicht mehr ntig.

  Revision 1.33  2003/08/20 06:56:57  mw
  MW: - Arg, 386er haben noch nicht zwangslufig einen Numerischen Copro
        Daher jetzt auch alternative xpspace mit Anzeige ber 2 GB.

      - Copro-Routinen berall gekapselt um Non8087-Version zu erlauben.

  Revision 1.32  2003/08/01 23:18:21  my
  MY:- About-, Beta-, und alle sonstigen Dialoge, Ausgaben und
       Versionsmeldungen auf "FreeXP" umgestellt.

  Revision 1.31  2003/07/30 23:09:51  my
  MY:- Source-Header auf "FreeXP" aktualisiert, einige Detailkorrekturen
       an CVS-Logs vorgenommen und hier und da CVS-Loginfos implementiert.

  Revision 1.30  2003/06/25 17:30:41  tw
  auto-de-branching

  Revision 1.29.2.25  2003/04/13 21:13:28  my
  MY:- PM aus Copyright entfernt

  Revision 1.29.2.24  2003/04/13 21:06:13  my
  MY:- 'xmsstr' wieder entfernt (=> 'ovrstr' in xp0.pas).

  Revision 1.29.2.23  2003/01/16 23:30:33  my
  MY: - Schalter /xmsovr in Versionsbezeichnung bercksichtigt
      - betastr an einigen Stellen ergnzt

  Revision 1.29.2.22  2003/01/10 22:16:20  my
  MY:- Log-Kosmetik

  Revision 1.29.2.21  2003/01/10 14:01:35  mw
  MW: - Wir haben jetzt 2003

  Revision 1.29.2.20  2002/03/09 21:50:13  my
  MY:- Versionsstrings korrigiert/gendert:
       - Snapshot-Versionsstrings werden jetzt nach dem Muster
         "CrossPoint [OpenXP/16] v3.40 RC3 @ 0903022151 R/C816" gebildet
         (zustzliche Leerzeichen vor Beta-String und vor/nach "@").
       - Bei ausgehenden Fido-Nachrichten wird jetzt derselbe Versionsstring
         erzeugt wie bei allen anderen Netztypen.
       - Bei eingehenden Fido-Nachrichten wird in der MAILER-Zeile die
         Tearline jetzt nur noch dann mit " / " an die PID angehngt, wenn
         PID und Tearline nicht gleich sind und die PID keinen der Strings
         "crosspoint", "openxp", "xp2" oder "xp " enthlt.

  Revision 1.29.2.19  2002/03/08 23:40:11  my
  MY:- Registrierungs-, Beta-, "ber OpenXP"- und sonstige Dialoge auf
       OpenXP/16 umgestellt und Copyright-Hinweise sowie Kontakte
       aktualisiert.

  Revision 1.29.2.18  2001/09/16 20:42:28  my
  JG+MY:- Neuer Menpunkt "?" (Hilfe) im Hauptmen mit Untermens fr
          ntzliche und/oder in der Hilfe ansonsten nur schwer auffindbare
          Informationen. Untermen "ber OpenXP" zeigt Versions- und
          Snapshotnummer sowie OpenXP-Kontakte an. Beta- und
          Registrierungsfenster optisch angepat.

  MY:- Copyright-/Lizenz-Header aktualisiert

  Revision 1.29.2.17  2001/06/27 15:35:06  my
  - changed string for RFC/Client netcalls

  Revision 1.29.2.16  2001/06/09 17:46:24  mk
  - Copyright auf 2000-01 geaendert

  Revision 1.29.2.15  2001/06/07 15:42:59  mk
  - Copyright auf 2001 geaendert

  Revision 1.29.2.14  2001/04/09 16:47:19  mk
  - arbeiten am Client-Modus

  Revision 1.29.2.13  2001/01/10 17:39:07  mk
  - PPP-Modus, unversandt, Ruecklaeufer ersetzen, VGA-Palette,
    UUZ und Bugfixes

  Revision 1.29.2.12  2001/01/02 11:43:17  mk
  - Versionnummer auf RC3 geaendert

  Revision 1.29.2.11  2000/12/27 20:08:03  mk
  - Versionsnummer auf RC2 geaendert

  Revision 1.29.2.10  2000/12/26 21:07:02  mk
  - Versionsnummer auf 3.40 RC1 geaendert

  Revision 1.29.2.9  2000/12/06 09:41:20  mk
  - OpenXP-Team mit Bindestrich in der Mitte

  Revision 1.29.2.8  2000/11/17 19:43:44  mk
  - Versionsnummer auf 3.30.7 geaendert

  Revision 1.29.2.7  2000/09/08 15:52:30  mk
  - Versionsnummer erhoeht

  Revision 1.29.2.6  2000/08/18 08:51:24  mk
  - Versionsnummer auf 3.30.5 geaendert

  Revision 1.29.2.5  2000/08/13 11:21:55  mk
  - Versionsnummer auf 3.30.4 geaendert

  Revision 1.29.2.4  2000/07/07 18:39:56  mk
  - Versionsnummer auf 3.30.3 gesetzt

  Revision 1.29.2.3  2000/07/01 09:22:58  mk
  - Mailerstringanpassungen

  Revision 1.29.2.2  2000/06/26 17:57:21  mk
  - Versionsnummer auf 3.30.2 gesetzt

  Revision 1.29.2.1  2000/06/22 17:13:46  mk
  - 32 Bit Teile entfernt

  Revision 1.29  2000/06/22 14:45:51  mk
  - Versionsnummer auf 3.30.1 geaendert

  Revision 1.28  2000/05/22 16:30:22  hd
  - _MPMask fuer den Ersatz bei multipos(':\',path)

  Revision 1.27  2000/05/14 09:19:22  mk
  - Debuginfos eingeschaltet und Beta 25 eingetragen

  Revision 1.26  2000/05/13 09:31:35  mk
  - Debugstringausgabe unter FPC

  Revision 1.25  2000/05/09 13:14:32  hd
  - DirSepa abhaengig von UnixFS, ebenso WildCard
  - MaxLenFilename/-Pathname eingefuehrt (bitte DOS etc. anpassen)

  Revision 1.24  2000/05/07 11:29:48  ml
  Bug in typeform unter Linux keine '\' als Verzeichnistrennung...

  Revision 1.23  2000/04/24 08:10:11  mk
  - Versionsinfo auf 3.21.024 angepasst

  Revision 1.22  2000/04/23 07:58:54  mk
  - OS/2-Portierung

  Revision 1.21  2000/04/13 12:48:40  mk
  - Anpassungen an Virtual Pascal
  - Fehler bei FindFirst behoben
  - Bugfixes bei 32 Bit Assembler-Routinen
  - Einige unkritische Memory Leaks beseitigt
  - Einge Write-Routinen durch Wrt/Wrt2 ersetzt
  - fehlende CVS Keywords in einigen Units hinzugefuegt
  - ZPR auf VP portiert
  - Winxp.ConsoleWrite provisorisch auf DOS/Linux portiert
  - Automatische Anpassung der Zeilenzahl an Consolengroesse in Win32

  Revision 1.20  2000/04/04 21:01:24  mk
  - Bugfixes fr VP sowie Assembler-Routinen an VP angepasst

  Revision 1.19  2000/03/24 20:25:50  rb
  ASM-Routinen gesubert, Register fr VP + FPC angegeben,
  Portierung FPC <-> VP

  Revision 1.18  2000/03/24 15:41:02  mk
  - FPC Spezifische Liste der benutzten ASM-Register eingeklammert

  Revision 1.17  2000/03/24 08:35:30  mk
  - Compilerfaehigkeit unter FPC wieder hergestellt

  Revision 1.16  2000/03/24 00:03:39  rb
  erste Anpassungen fr die portierung mit VP

  Revision 1.15  2000/03/22 18:18:44  mk
  - Versionsinfo auf 3.21.23 geaendert

  Revision 1.14  2000/03/17 11:16:35  mk
  - Benutzte Register in 32 Bit ASM-Routinen angegeben, Bugfixes

  Revision 1.13  2000/03/16 10:14:25  mk
  - Ver32: Tickerabfrage optimiert
  - Ver32: Buffergroessen fr Ein-/Ausgabe vergroessert
  - Ver32: Keypressed-Routine laeuft nach der letzen nderung wieder

  Revision 1.12  2000/03/14 18:16:15  mk
  - 16 Bit Integer unter FPC auf 32 Bit Integer umgestellt

  Revision 1.11  2000/03/09 23:39:34  mk
  - Portierung: 32 Bit Version laeuft fast vollstaendig

  Revision 1.10  2000/03/08 22:36:33  mk
  - Bugfixes fr die 32 Bit-Version und neue ASM-Routinen

  Revision 1.9  2000/03/06 08:51:04  mk
  - OpenXP/32 ist jetzt Realitaet

  Revision 1.8  2000/03/04 11:53:20  mk
  Version auf 3.21.022 beta geaendert und Debug eingeschaltet

  Revision 1.7  2000/03/02 18:32:24  mk
  - Code ein wenig aufgeraeumt

}
